=== debian/changelog ===
pcmciautils (018-18) unstable; urgency=medium

  [ Petter Reinholdtsen ]
  * Fix component type in Appstream metainfo (closes: #1077783).

 -- Colin Watson <cjwatson@debian.org>  Fri, 02 Aug 2024 10:58:56 +0100

pcmciautils (018-17) unstable; urgency=medium

  [ Colin Watson ]
  * Apply X-Style: black.

  [ Petter Reinholdtsen ]
  * Add Appstream metainfo announcing HW support (closes: #1077051).

 -- Colin Watson <cjwatson@debian.org>  Thu, 25 Jul 2024 19:27:17 +0100

pcmciautils (018-16) unstable; urgency=medium

  * Upload to unstable.

 -- Colin Watson <cjwatson@debian.org>  Mon, 10 Jun 2024 16:57:13 +0100

pcmciautils (018-15) experimental; urgency=medium

  * Update watch file format version to 4.
  * Add dh-sequence-movetousr.

 -- Colin Watson <cjwatson@debian.org>  Mon, 03 Jun 2024 11:10:29 +0100

pcmciautils (018-14) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on dpkg-dev.
    + Remove 2 maintscript entries from 1 files.
  * Add missing ${misc:Depends} to Depends for pcmciautils-udeb.
  * Bump debhelper from old 11 to 13.

 -- Colin Watson <cjwatson@debian.org>  Fri, 16 Dec 2022 16:52:13 +0000

pcmciautils (018-13) unstable; urgency=medium

  [ Holger Wansing ]
  * Update /etc/pcmciautils/ dir to /etc/pcmcia/ in udeb (closes: #980271).

 -- Colin Watson <cjwatson@debian.org>  Tue, 15 Jun 2021 13:51:17 +0100

pcmciautils (018-12) unstable; urgency=medium

  [ Bor Grošelj Simić ]
  * makefile: unbreak parallel building.

 -- Colin Watson <cjwatson@debian.org>  Sun, 20 Sep 2020 22:47:40 +0100

pcmciautils (018-11) unstable; urgency=medium

  * Use debhelper-compat instead of debian/compat.
  * Silence postrm error if /etc/pcmcia is not empty (closes: #951036).

 -- Colin Watson <cjwatson@debian.org>  Mon, 10 Feb 2020 11:45:52 +0000

pcmciautils (018-10) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

  [ Colin Watson ]
  * Simplify debian/rules using /usr/share/dpkg/default.mk.
  * Set Rules-Requires-Root: no.
  * Upgrade to debhelper v11.
  * Convert debian/copyright to copyright-format 1.0.
  * Support DEB_BUILD_OPTIONS=terse.
  * Policy version 4.2.1.

 -- Colin Watson <cjwatson@debian.org>  Sat, 27 Oct 2018 22:16:05 +0100

pcmciautils (018-9) unstable; urgency=low

  * Add a Vcs-Browser field (closes: #681622).
  * Simplify debian/rules using /usr/share/dpkg/buildflags.mk.
  * Use Package-Type rather than XC-Package-Type, now that it is an official
    field.
  * Change priority to optional, since "Priority: extra" is now deprecated.
  * Switch to git; adjust Vcs-* fields.
  * Update homepage and download URLs (closes: #681622, #785805).
  * Remove Per Olofsson from Uploaders, with thanks for their previous
    contributions (closes: #847165).
  * Convert to git-dpm, and drop the debian/rules quilt-setup target
    associated with the old bzr/quilt patch handling workflow.

 -- Colin Watson <cjwatson@debian.org>  Sat, 14 Apr 2018 14:12:17 +0100

pcmciautils (018-8) unstable; urgency=low

  * Mark pcmciautils and pcmciautils-udeb Architecture: linux-any.

 -- Colin Watson <cjwatson@debian.org>  Mon, 25 Jun 2012 14:57:42 +0100

pcmciautils (018-7) unstable; urgency=low

  * Use dpkg-buildflags to enable hardening options.

 -- Colin Watson <cjwatson@debian.org>  Fri, 22 Jun 2012 13:55:20 +0100

pcmciautils (018-6) unstable; urgency=low

  * Prevent the upstream build system calling strip, and rely on dh_strip
    instead to honour Debian policy requirements.

 -- Colin Watson <cjwatson@debian.org>  Wed, 21 Mar 2012 18:49:30 +0000

pcmciautils (018-5) unstable; urgency=low

  * Use dh_installdeb's maintscript support rather than writing it into
    maintainer scripts by hand.  We now just pre-depend on a sufficient
    version of dpkg rather than using 'dpkg-maintscript-helper supports
    rm_conffile' guards.

 -- Colin Watson <cjwatson@debian.org>  Sat, 11 Feb 2012 14:27:49 +0000

pcmciautils (018-4) unstable; urgency=low

  * Add cross-compiling support.

 -- Colin Watson <cjwatson@debian.org>  Fri, 16 Sep 2011 10:59:13 +0100

pcmciautils (018-3) unstable; urgency=low

  * Also remove libsysfs-dev from build-deps.

 -- Per Olofsson <pelle@debian.org>  Sun, 12 Jun 2011 20:29:55 +0200

pcmciautils (018-2) unstable; urgency=low

  [ Per Olofsson ]
  * Remove module-init-tools and lsb-base from Depends, since the init
    script is now gone.
  * Rename debian/pcmciautils.docs to debian/docs.
  * Actually remove unnecessary-linkage.patch, not only from series.
  * Add patch remove-libsysfs-dep.patch from upstream to remove
    dependency on libsysfs. Closes: #627648.

  [ Colin Watson ]
  * Update Vcs-Bzr field for Alioth changes.

 -- Per Olofsson <pelle@debian.org>  Sun, 12 Jun 2011 19:53:52 +0200

pcmciautils (018-1) unstable; urgency=low

  [ Colin Watson ]
  * udev rules are now installed in /lib/udev/rules.d/ (closes: #575830).
    Preserve any user changes found in /etc/udev/pcmcia.rules.
  * Convert to source format 3.0 (quilt) and DEP-3 patch tagging.

  [ Per Olofsson ]
  * New upstream release.
    - Drop unnecessary-linkage.patch, applied upstream.
  * Remove obsolete README.Debian.
  * Bump Standards-Version to 3.9.2. No changes.
  * Remove init script. Driver module should be loaded by udev or
    /etc/modules. Add note to NEWS.Debian.
  * Simplify debian/rules.
  * Remove old cruft from maintainer scripts.
  * Create /etc/pcmcia directory if it doesn't exist.

 -- Per Olofsson <pelle@debian.org>  Mon, 25 Apr 2011 22:33:46 +0200

pcmciautils (015-1) unstable; urgency=low

  * New upstream release.
    - Simplified the setting of sysfs attributes; requires udev 098.
  * Vcs-Bzr is now an official field.
  * Add a Homepage field.
  * Don't link pcmcia-check-broken-cis against libsysfs; dpkg-shlibdeps
    reports that it doesn't need it.
  * The init script should either print a message and exit non-zero, or be

