=== debian/control ===
Source: pcmciautils
Section: admin
Priority: optional
Maintainer: Colin Watson <cjwatson@debian.org>
Standards-Version: 4.2.1
Vcs-Git: https://salsa.debian.org/debian/pcmciautils.git
Vcs-Browser: https://salsa.debian.org/debian/pcmciautils
Build-Depends:
 bison,
 debhelper-compat (= 13),
 dh-sequence-movetousr,
 flex,
Homepage: https://www.kernel.org/pub/linux/utils/kernel/pcmcia/
Rules-Requires-Root: no
X-Style: black

Package: pcmciautils
Architecture: linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 udev,
Suggests:
 wireless-tools,
Description: PCMCIA utilities for Linux 2.6
 This package provides PCMCIA initialisation tools for Linux 2.6.13-rc1 or
 later, replacing the old pcmcia-cs tools used with earlier kernel versions.
 PCMCIA cards are commonly used in laptops to provide expanded capabilities
 such as network connections, modems, increased memory, etc.
 .
 To use PCMCIA you need to have kernel modules available to support
 it. These are included in the stock Debian 2.6 kernel packages. You
 will most likely also need udev, although it isn't always required.
 .
 The wireless-tools package is required by many wireless network adapters.

Package: pcmciautils-udeb
Package-Type: udeb
Section: debian-installer
Architecture: linux-any
Depends:
 udev-udeb,
 ${misc:Depends},
 ${shlibs:Depends},
Description: PCMCIA utilities for Linux 2.6
 This package provides PCMCIA initialisation tools for Linux 2.6.13-rc1 or
 later, replacing the old pcmcia-cs tools used with earlier kernel versions.
 PCMCIA cards are commonly used in laptops to provide expanded capabilities
 such as network connections, modems, increased memory, etc.
 .
 To use PCMCIA you need to have kernel modules available to support it.
 These are included in the stock Debian 2.6 kernel packages.
 .
 This is a minimal package for use in debian-installer.
