=== debian/rules ===
#! /usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS := 1
include /usr/share/dpkg/default.mk

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
export V := true
endif

%:
	dh $@

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
CROSS :=
else
CROSS := CROSS=$(DEB_HOST_GNU_TYPE)-
endif

override_dh_auto_build:
	$(MAKE) $(CROSS) STRIPCMD=true

override_dh_auto_install:
	dh_auto_install --destdir=debian/pcmciautils -- \
		pcmciaconfdir=/usr/lib/pcmciautils

override_dh_install:
	dh_install --sourcedir=debian/pcmciautils
