=== debian/watch ===
version=4
https://www.kernel.org/pub/linux/utils/kernel/pcmcia pcmciautils-(.*)\.tar\.gz
